;**************************************************************************************************************************************************
;   PROJECT:      Generatore di Funzioni DSS
;   FILE:         EXPOS.asm
;   LAST REV:     1.4
;	AUTHOR:       Ivo Colleoni
;  	DEVICE:       PIC18F2550
;	CREATED:	  15/02/2013
;	UPDATED:	  29/04/2013
;
;	DESCRIP:      Funzioni di scrittura su DISPLAY LCD
;
;--------------------------------------------------------------------------------------------------------------------------------------------------
;   Change History:
;  	Rev.    Date                Changes
;   1.4     29/04/2013          - modificato ciclo esposizione Vpp (adattamento multiplexer)
;   1.3     22/04/2013          - aggiunte scritte offset onda quadra
;   1.2     05/04/2013          - aggunte scritte offset
;   1.1     30/03/2013          - aggunte scritte vpp
;   1.0     15/02/2013          - prima build
;
;**************************************************************************************************************************************************
;SCRITTE STATICHE
;**************************************************************************************************************************************************
;**************************************************************************************************************************************************
;   FUNCTION:       EXPO_NAME
;   Overview:       scrive    DSS Waveform
;                             Generator
;                             by Ivo Colleoni
;**************************************************************************************************************************************************
;
EXPO_NAME    		movlw		        LCD_CLEAR				                        ;pulizia display
					call		        LCD_SEND_CODE

                    movlw		        d'3'                                            ;mi sposto in posizione 3 della prima riga
					call		        LCD_MOVE_LOC_R1

					movlw		        c_D
					call		        LCD_SEND_DATA
                    movlw		        c_S
					call		        LCD_SEND_DATA
                    movlw		        c_S
					call		        LCD_SEND_DATA

                    movlw		        d'9'                                            ;mi sposto in posizione 9 della prima riga
					call		        LCD_MOVE_LOC_R1

                    movlw		        c_W
					call		        LCD_SEND_DATA
                    movlw		        c_a
					call		        LCD_SEND_DATA
                    movlw		        c_v
					call		        LCD_SEND_DATA
                    movlw		        c_e
					call		        LCD_SEND_DATA
                    movlw		        c_f
					call		        LCD_SEND_DATA
                    movlw		        c_o
					call		        LCD_SEND_DATA
                    movlw		        c_r
					call		        LCD_SEND_DATA
                    movlw		        c_m
					call		        LCD_SEND_DATA

                    movlw		        d'3'                                            ;mi sposto in posizione 3 della seconda riga
					call		        LCD_MOVE_LOC_R2

                    movlw		        c_G
					call		        LCD_SEND_DATA
                    movlw		        c_e
					call		        LCD_SEND_DATA
                    movlw		        c_n
					call		        LCD_SEND_DATA
                    movlw		        c_e
					call		        LCD_SEND_DATA
                    movlw		        c_r
					call		        LCD_SEND_DATA
                    movlw		        c_a
					call		        LCD_SEND_DATA
                    movlw		        c_t
					call		        LCD_SEND_DATA
                    movlw		        c_o
					call		        LCD_SEND_DATA
                    movlw		        c_r
					call		        LCD_SEND_DATA

                    movlw		        d'2'                                            ;mi sposto in posizione 2 della quarta riga
					call		        LCD_MOVE_LOC_R4

                    movlw		        c_b
					call		        LCD_SEND_DATA
                    movlw		        c_y
					call		        LCD_SEND_DATA

                    movlw		        c_
					call		        LCD_SEND_DATA
                    movlw		        c_
					call		        LCD_SEND_DATA

                    movlw		        c_I
					call		        LCD_SEND_DATA
                    movlw		        c_v
					call		        LCD_SEND_DATA
                    movlw		        c_o
					call		        LCD_SEND_DATA

                    movlw		        c_
					call		        LCD_SEND_DATA

                    movlw		        c_C
					call		        LCD_SEND_DATA
                    movlw		        c_o
					call		        LCD_SEND_DATA
                    movlw		        c_l
					call		        LCD_SEND_DATA
                    movlw		        c_l
					call		        LCD_SEND_DATA
                    movlw		        c_e
					call		        LCD_SEND_DATA
                    movlw		        c_o
					call		        LCD_SEND_DATA
                    movlw		        c_n
					call		        LCD_SEND_DATA
                    movlw		        c_i
					call		        LCD_SEND_DATA

                    return
;
;**************************************************************************************************************************************************
;   FUNCTION:       EXPO_INFO
;   Precondition:   Dichiarare le costanti HW_REV e FW_REV nel programma principale
;   Overview:       scrive      Hardware rev. x.xx
;                               Firmware rev. x.xx
;**************************************************************************************************************************************************
;
EXPO_INFO    		movlw		        LCD_CLEAR				                        ;pulizia display
					call		        LCD_SEND_CODE

                    movlw		        d'1'                                            ;mi sposto in posizione 2 della seconda riga
					call		        LCD_MOVE_LOC_R2

					movlw		        c_H
					call		        LCD_SEND_DATA
					movlw		        c_a
					call		        LCD_SEND_DATA
					movlw		        c_r
					call		        LCD_SEND_DATA
					movlw		        c_d
					call		        LCD_SEND_DATA
					movlw		        c_w
					call		        LCD_SEND_DATA
					movlw		        c_a
					call		        LCD_SEND_DATA
					movlw		        c_r
					call		        LCD_SEND_DATA
					movlw		        c_e
					call		        LCD_SEND_DATA

					movlw		        c_
					call		        LCD_SEND_DATA

					movlw		        c_r
					call		        LCD_SEND_DATA
					movlw		        c_e
					call		        LCD_SEND_DATA
					movlw		        c_v
					call		        LCD_SEND_DATA
					movlw		        c_.
					call		        LCD_SEND_DATA

                    movlw		        c_
					call		        LCD_SEND_DATA

					movlw		        HW_REV_0
					call		        LCD_SEND_NUMBER
					movlw               c_.
					call		        LCD_SEND_DATA
					movlw		        HW_REV_1
					call		        LCD_SEND_NUMBER
					movlw		        HW_REV_2
					call		        LCD_SEND_NUMBER

                    movlw		        d'1'                                            ;mi sposto in posizione 2 della terza riga
					call		        LCD_MOVE_LOC_R3

					movlw		        c_F
					call		        LCD_SEND_DATA
					movlw		        c_i
					call		        LCD_SEND_DATA
					movlw		        c_r
					call		        LCD_SEND_DATA
					movlw		        c_m
					call		        LCD_SEND_DATA
					movlw		        c_w
					call		        LCD_SEND_DATA
					movlw		        c_a
					call		        LCD_SEND_DATA
					movlw		        c_r
					call		        LCD_SEND_DATA
					movlw		        c_e
					call		        LCD_SEND_DATA

					movlw		        c_
					call		        LCD_SEND_DATA

					movlw		        c_r
					call		        LCD_SEND_DATA
					movlw		        c_e
					call		        LCD_SEND_DATA
					movlw		        c_v
					call		        LCD_SEND_DATA
					movlw		        c_.
					call		        LCD_SEND_DATA

                    movlw		        c_
					call		        LCD_SEND_DATA

					movlw		        FW_REV_0
					call		        LCD_SEND_NUMBER
					movlw               c_.
					call		        LCD_SEND_DATA
					movlw		        FW_REV_1
					call		        LCD_SEND_NUMBER
					movlw		        FW_REV_2
					call		        LCD_SEND_NUMBER

                    return
;
;**************************************************************************************************************************************************
;   FUNCTION:       EXPO_STATIC
;   Overview:       scrive    Waveform:
;                             Freq:
;                             Phase:
;                             Vpp:
;**************************************************************************************************************************************************
;
EXPO_STATIC 		movlw		        LCD_CLEAR				                        ;pulizia display
					call		        LCD_SEND_CODE

					movlw		        c_W
					call		        LCD_SEND_DATA
					movlw		        c_a
					call		        LCD_SEND_DATA
					movlw		        c_v
					call		        LCD_SEND_DATA
					movlw		        c_e
                    call		        LCD_SEND_DATA
					movlw		        h'3A'											;:
					call		        LCD_SEND_DATA

					movlw		        d'0'                                            ;mi sposto in posizione 0 della seconda riga
					call		        LCD_MOVE_LOC_R2

	                movlw		        c_F
					call		        LCD_SEND_DATA
					movlw		        c_r
					call		        LCD_SEND_DATA
					movlw		        c_e
					call		        LCD_SEND_DATA
					movlw		        c_q
					call		        LCD_SEND_DATA
					movlw		        h'3A'											;:
					call		        LCD_SEND_DATA

					movlw		        d'0'                                            ;mi sposto in posizione 0 della terza riga
					call		        LCD_MOVE_LOC_R3

	                movlw		        c_P
					call		        LCD_SEND_DATA
					movlw		        c_h
					call		        LCD_SEND_DATA
					movlw		        c_a
					call		        LCD_SEND_DATA
					movlw		        c_s
					call		        LCD_SEND_DATA
					movlw		        c_e
					call		        LCD_SEND_DATA
					movlw		        h'3A'											;:
					call		        LCD_SEND_DATA

					movlw		        d'0'                                            ;mi sposto in posizione 0 della quarta riga
					call		        LCD_MOVE_LOC_R4

	                movlw		        c_V
					call		        LCD_SEND_DATA
					movlw		        c_p
					call		        LCD_SEND_DATA
					movlw		        c_p
					call		        LCD_SEND_DATA
					movlw		        h'3A'											;:
					call		        LCD_SEND_DATA

                    return
;
;**************************************************************************************************************************************************
;   FUNCTION:       EXPO_PAGE_2
;   Overview:       scrive    Backill:
;                             Contrast:
;                             Offset:
;**************************************************************************************************************************************************
;
EXPO_PAGE_2         movlw               LCD_CLEAR
                    call                LCD_SEND_CODE

                    movlw               c_B
                    call                LCD_SEND_DATA
                    movlw               c_a
                    call                LCD_SEND_DATA
                    movlw               c_c
                    call                LCD_SEND_DATA
                    movlw               c_k
                    call                LCD_SEND_DATA
                    movlw               c_i
                    call                LCD_SEND_DATA
                    movlw               c_l
                    call                LCD_SEND_DATA
                    movlw               c_l
                    call                LCD_SEND_DATA
                    movlw               c_.
                    call                LCD_SEND_DATA
                    movlw               h'3A'
                    call                LCD_SEND_DATA

                    movlw               d'0'
                    call                LCD_MOVE_LOC_R2

                    movlw               c_C
                    call                LCD_SEND_DATA
                    movlw               c_o
                    call                LCD_SEND_DATA
                    movlw               c_n
                    call                LCD_SEND_DATA
                    movlw               c_t
                    call                LCD_SEND_DATA
                    movlw               c_r
                    call                LCD_SEND_DATA
                    movlw               c_a
                    call                LCD_SEND_DATA
                    movlw               c_s
                    call                LCD_SEND_DATA
                    movlw               c_t
                    call                LCD_SEND_DATA
                    movlw               h'3A'
                    call                LCD_SEND_DATA

                    movlw               d'0'
                    call                LCD_MOVE_LOC_R3

                    movlw               c_O
                    call                LCD_SEND_DATA
                    movlw               c_f
                    call                LCD_SEND_DATA
                    movlw               c_f
                    call                LCD_SEND_DATA
                    movlw               c_s
                    call                LCD_SEND_DATA
                    movlw               c_e
                    call                LCD_SEND_DATA
                    movlw               c_t
                    call                LCD_SEND_DATA
                    movlw               h'3A'
                    call                LCD_SEND_DATA

                    movlw               d'0'
                    call                LCD_MOVE_LOC_R4

                    movlw               c_O
                    call                LCD_SEND_DATA
                    movlw               c_f
                    call                LCD_SEND_DATA
                    movlw               c_f
                    call                LCD_SEND_DATA
                    movlw               c_s
                    call                LCD_SEND_DATA
                    movlw               c_e
                    call                LCD_SEND_DATA
                    movlw               c_t
                    call                LCD_SEND_DATA
                    movlw               c_S
                    call                LCD_SEND_DATA
                    movlw               c_q
                    call                LCD_SEND_DATA
                    movlw               h'3A'
                    call                LCD_SEND_DATA

                    return
;
;**************************************************************************************************************************************************
;   FUNCTION:       EXPO_FIRST_START
;   Overview:       sctitte esposte al primo avvio per la programmazione del potenziometro
;**************************************************************************************************************************************************
;
EXPO_FIRST_START    movlw		        LCD_CLEAR				                        ;pulizia display
					call		        LCD_SEND_CODE

                    movlw               d'0'
                    call                LCD_MOVE_LOC_R1

                    movlw               c_I
                    call                LCD_SEND_DATA
                    movlw               c_n
                    call                LCD_SEND_DATA
                    movlw               c_l
                    call                LCD_SEND_DATA
                    movlw               c_z
                    call                LCD_SEND_DATA
                    movlw               c_i
                    call                LCD_SEND_DATA
                    movlw               c_a
                    call                LCD_SEND_DATA
                    movlw               c_l
                    call                LCD_SEND_DATA
                    movlw               c_i
                    call                LCD_SEND_DATA
                    movlw               c_z
                    call                LCD_SEND_DATA
                    movlw               c_i
                    call                LCD_SEND_DATA
                    movlw               c_n
                    call                LCD_SEND_DATA
                    movlw               c_g
                    call                LCD_SEND_DATA
                    movlw               c_.
                    call                LCD_SEND_DATA
                    movlw               c_.
                    call                LCD_SEND_DATA
                    movlw               c_.
                    call                LCD_SEND_DATA
                    
                    return
;
;**************************************************************************************************************************************************
;   FUNCTION:       EXPO_MENU_SWAP
;   Overview:       Espone le scritte nel menu di swap
;**************************************************************************************************************************************************
;
EXPO_MENU_SWAP      movlw               LCD_CLEAR
                    call                LCD_SEND_CODE

                    movlw				d'0'
					call		        LCD_MOVE_LOC_R1

                    movlw		        d'1'
					call		        LCD_SEND_NUMBER
                    movlw		        c_H
					call		        LCD_SEND_DATA
                    movlw		        c_z
					call		        LCD_SEND_DATA
                    movlw		        c_
					call		        LCD_SEND_DATA
                    movlw		        c_t
					call		        LCD_SEND_DATA
                    movlw		        c_o
					call		        LCD_SEND_DATA
                    movlw		        c_
					call		        LCD_SEND_DATA
                    movlw		        d'1'
					call		        LCD_SEND_NUMBER
                    movlw		        c_M
					call		        LCD_SEND_DATA
                    movlw		        c_H
					call		        LCD_SEND_DATA
                    movlw		        c_z
                    call		        LCD_SEND_DATA

                    movlw				d'0'
					call		        LCD_MOVE_LOC_R2

                    movlw		        d'2'
					call		        LCD_SEND_NUMBER
                    movlw		        d'0'
					call		        LCD_SEND_NUMBER
                    movlw		        c_H
					call		        LCD_SEND_DATA
                    movlw		        c_z
					call		        LCD_SEND_DATA
                    movlw		        c_
					call		        LCD_SEND_DATA
                    movlw		        c_t
					call		        LCD_SEND_DATA
                    movlw		        c_o
					call		        LCD_SEND_DATA
                    movlw		        c_
					call		        LCD_SEND_DATA
                    movlw		        d'4'
					call		        LCD_SEND_NUMBER
                    movlw		        d'4'
					call		        LCD_SEND_NUMBER
                    movlw		        c_K
					call		        LCD_SEND_DATA
                    movlw		        c_H
					call		        LCD_SEND_DATA
                    movlw		        c_z
                    call		        LCD_SEND_DATA

            		movlw				d'12'
					call		        LCD_MOVE_LOC_R4

                    movlw		        c_B
					call		        LCD_SEND_DATA
                    movlw		        c_K
					call		        LCD_SEND_DATA

                    movlw		        c_
					call		        LCD_SEND_DATA

                    movlw		        c_S
					call		        LCD_SEND_DATA
					movlw		        c_T
					call		        LCD_SEND_DATA
					movlw		        c_A
					call		        LCD_SEND_DATA
					movlw		        c_R											;:
					call		        LCD_SEND_DATA
                    movlw		        c_T											;:
					call		        LCD_SEND_DATA

					return
;
;**************************************************************************************************************************************************
;   FUNCTION:       EXPO_SWAP
;   Overview:       Espone la scritta SWAP
;**************************************************************************************************************************************************
;
EXPO_SWAP           movlw               d'16'
                    call                LCD_MOVE_LOC_R4

                    movlw		        c_S
					call		        LCD_SEND_DATA
					movlw		        c_w
					call		        LCD_SEND_DATA
					movlw		        c_a
					call		        LCD_SEND_DATA
					movlw		        c_p											;:
					call		        LCD_SEND_DATA

                    return
;
;**************************************************************************************************************************************************
;   FUNCTION:       EXPO_OK_NEXT
;   Overview:       Espone le scritte OK e NEXT
;**************************************************************************************************************************************************
;
EXPO_OK_NEXT		movlw				d'13'                                           ;aggiungo le scritte di setup
					call		        LCD_MOVE_LOC_R4

                    movlw		        c_O
					call		        LCD_SEND_DATA
                    movlw		        c_K
					call		        LCD_SEND_DATA

                    movlw		        c_
					call		        LCD_SEND_DATA

                    movlw		        c_N
					call		        LCD_SEND_DATA
					movlw		        c_E
					call		        LCD_SEND_DATA
					movlw		        c_X
					call		        LCD_SEND_DATA
					movlw		        c_T											;:
					call		        LCD_SEND_DATA

					return
;
;**************************************************************************************************************************************************
;   FUNCTION:       DELETE_OK_NEXT
;   Overview:       Cancella le scritte OK e NEXT
;**************************************************************************************************************************************************
;
DELETE_OK_NEXT		movlw				d'13'                                           ;Cancello le scritte dei setup all'uscita del cicli di settaggio
					call		        LCD_MOVE_LOC_R4

                    movlw		        c_
					call		        LCD_SEND_DATA
                    movlw		        c_
					call		        LCD_SEND_DATA

                    movlw		        c_
					call		        LCD_SEND_DATA

                    movlw		        c_
					call		        LCD_SEND_DATA
					movlw		        c_
					call		        LCD_SEND_DATA
					movlw		        c_
					call		        LCD_SEND_DATA
					movlw		        c_											;:
					call		        LCD_SEND_DATA

					return
;
;**************************************************************************************************************************************************
;   FUNCTION:       EXPO_STOP
;   Overview:       espone la scritta STOP
;**************************************************************************************************************************************************
;
EXPO_STOP   		movlw				d'12'                                           
					call		        LCD_MOVE_LOC_R4

                    movlw		        c_
					call		        LCD_SEND_DATA
                    movlw		        c_
					call		        LCD_SEND_DATA
                    movlw		        c_  
					call		        LCD_SEND_DATA

                    movlw		        c_
					call		        LCD_SEND_DATA

                    movlw		        c_S
					call		        LCD_SEND_DATA
					movlw		        c_T
					call		        LCD_SEND_DATA
					movlw		        c_O
					call		        LCD_SEND_DATA
					movlw		        c_P											;:
					call		        LCD_SEND_DATA

					return
;
;**************************************************************************************************************************************************
;   FUNCTION:       EXPO_ARROW
;   Overview:       Espone le frecce
;**************************************************************************************************************************************************
;
EXPO_ARROW     		movlw				d'13'                                           ;aggiungo le scritte di setup
					call		        LCD_MOVE_LOC_R4

                    movlw		        h'7F'
					call		        LCD_SEND_DATA
                    movlw		        c_
					call		        LCD_SEND_DATA

                    movlw		        c_
					call		        LCD_SEND_DATA

                    movlw		        c_
					call		        LCD_SEND_DATA
					movlw		        c_
					call		        LCD_SEND_DATA
					movlw		        h'7E'
					call		        LCD_SEND_DATA
					movlw		        c_											;:
					call		        LCD_SEND_DATA

					return
;
;**************************************************************************************************************************************************
;   FUNCTION:       EXPO_BK_NEXT
;   Overview:       Espone le scritte BK e NEXT
;**************************************************************************************************************************************************
;
EXPO_BK_NEXT        movlw				d'13'                                           ;aggiungo le scritte di setup
					call		        LCD_MOVE_LOC_R4

                    movlw		        c_B
					call		        LCD_SEND_DATA
                    movlw		        c_K
					call		        LCD_SEND_DATA

                    movlw		        c_
					call		        LCD_SEND_DATA

                    movlw		        c_N
					call		        LCD_SEND_DATA
					movlw		        c_E
					call		        LCD_SEND_DATA
					movlw		        c_X
					call		        LCD_SEND_DATA
					movlw		        c_T										
					call		        LCD_SEND_DATA

                    return
;
;**************************************************************************************************************************************************
;   FUNCTION:       EXPO_BK_SAVE
;   Overview:       Espone le scritte BK e SAVE
;**************************************************************************************************************************************************
;
EXPO_BK_SAVE		movlw				d'13'                                           ;aggiungo le scritte di setup
					call		        LCD_MOVE_LOC_R4

                    movlw		        c_B
					call		        LCD_SEND_DATA
                    movlw		        c_K
					call		        LCD_SEND_DATA

                    movlw		        c_
					call		        LCD_SEND_DATA

                    movlw		        c_S
					call		        LCD_SEND_DATA
					movlw		        c_A
					call		        LCD_SEND_DATA
					movlw		        c_V
					call		        LCD_SEND_DATA
					movlw		        c_E
					call		        LCD_SEND_DATA

					return
;
;**************************************************************************************************************************************************
;   FUNCTION:       EXPO_SAVED
;   Overview:       Espone messaggio di salvataggio avvenuto
;**************************************************************************************************************************************************
;
EXPO_SAVED          movlw               LCD_CLEAR
                    call                LCD_SEND_CODE

                    movlw				d'0'
					call		        LCD_MOVE_LOC_R1

                    movlw		        c_D
					call		        LCD_SEND_DATA
                    movlw		        c_a
					call		        LCD_SEND_DATA
                    movlw		        c_t
					call		        LCD_SEND_DATA
                    movlw		        c_a
					call		        LCD_SEND_DATA
                    movlw		        c_
					call		        LCD_SEND_DATA
                    movlw		        c_s
					call		        LCD_SEND_DATA
                    movlw		        c_a
					call		        LCD_SEND_DATA
                    movlw		        c_v
					call		        LCD_SEND_DATA
                    movlw		        c_e
					call		        LCD_SEND_DATA
                    movlw		        c_d
					call		        LCD_SEND_DATA
                    movlw		        c_
					call		        LCD_SEND_DATA
                    movlw		        c_i
					call		        LCD_SEND_DATA
                    movlw		        c_n
					call		        LCD_SEND_DATA
                    movlw		        c_
					call		        LCD_SEND_DATA
                    movlw		        c_E
					call		        LCD_SEND_DATA
                    movlw		        c_E
					call		        LCD_SEND_DATA
                    movlw		        c_P
					call		        LCD_SEND_DATA
                    movlw		        c_R
					call		        LCD_SEND_DATA
                    movlw		        c_O
					call		        LCD_SEND_DATA
                    movlw		        c_M
					call		        LCD_SEND_DATA

                    movlw				d'0'
					call		        LCD_MOVE_LOC_R2

                    movlw		        c_M
					call		        LCD_SEND_DATA
                    movlw		        c_e
					call		        LCD_SEND_DATA
                    movlw		        c_m
					call		        LCD_SEND_DATA
                    movlw		        c_o
					call		        LCD_SEND_DATA
                    movlw		        c_r
					call		        LCD_SEND_DATA
                    movlw		        c_y
					call		        LCD_SEND_DATA
                    movlw		        c_.
					call		        LCD_SEND_DATA

                    movlw				d'0'
					call		        LCD_MOVE_LOC_R3

                    movlw		        c_T
					call		        LCD_SEND_DATA
                    movlw		        c_h
					call		        LCD_SEND_DATA
                    movlw		        c_e
					call		        LCD_SEND_DATA
                    movlw		        c_y
					call		        LCD_SEND_DATA
                    movlw		        c_
					call		        LCD_SEND_DATA
                    movlw		        c_w
					call		        LCD_SEND_DATA
                    movlw		        c_i
					call		        LCD_SEND_DATA
                    movlw		        c_l
					call		        LCD_SEND_DATA
                    movlw		        c_l
					call		        LCD_SEND_DATA
                    movlw		        c_
					call		        LCD_SEND_DATA
                    movlw		        c_b
					call		        LCD_SEND_DATA
                    movlw		        c_e
					call		        LCD_SEND_DATA
                    movlw		        c_
					call		        LCD_SEND_DATA
                    movlw		        c_l
					call		        LCD_SEND_DATA
                    movlw		        c_o
					call		        LCD_SEND_DATA
                    movlw		        c_a
					call		        LCD_SEND_DATA
                    movlw		        c_d
					call		        LCD_SEND_DATA
                    movlw		        c_e
					call		        LCD_SEND_DATA
                    movlw		        c_d
					call		        LCD_SEND_DATA

                    movlw				d'0'
					call		        LCD_MOVE_LOC_R4

                    movlw		        c_o
					call		        LCD_SEND_DATA
                    movlw		        c_n
					call		        LCD_SEND_DATA
                    movlw		        c_
					call		        LCD_SEND_DATA
                    movlw		        c_s
					call		        LCD_SEND_DATA
                    movlw		        c_t
					call		        LCD_SEND_DATA
                    movlw		        c_a
					call		        LCD_SEND_DATA
                    movlw		        c_r
					call		        LCD_SEND_DATA
                    movlw		        c_t
					call		        LCD_SEND_DATA
                    movlw		        c_u
					call		        LCD_SEND_DATA
                    movlw		        c_p
					call		        LCD_SEND_DATA

					return
;
;**************************************************************************************************************************************************
;**************************************************************************************************************************************************
;SCRITTE DINAMICHE DEI VALORI IMPOSTATI
;**************************************************************************************************************************************************
;**************************************************************************************************************************************************
; FUNCTION:         EXPO_SHAPE
; Input:            shape
; Overview:         Espone la forma d'onda selezionata: shape=0: quadra, shape=1:trian, shape=2: sin
;**************************************************************************************************************************************************
EXPO_SHAPE          movf                shape,W                                         ;se shape = 0
                    btfsc               STATUS,Z
                    goto                EXPO_SQU                                        ;vado a EXPO_SQU

                    movf                shape,W                                         ;se shape = 1
                    xorlw               h'1'
                    btfsc               STATUS,Z
                    goto                EXPO_TRI                                        ;vado a EXPO_TRI

                    movf                shape,W                                         ;se shape = 1
                    xorlw               h'2'
                    btfsc               STATUS,Z
                    goto                EXPO_SIN                                        ;vado a EXPO_SIN

                    call                EXPO_ERR_SHAPE                                  ;se nessuno dei valori precedenti espongo l'errore
ERR_LOOP_2          goto                ERR_LOOP_2                                      ;e mi fermo qui (usato in fase di debug, non dovrebbe mai verificarsi
                                                                                        ;questa condizione)
EXPO_SIN            movlw		        d'7'                                            ;mi sposto in posizione 7 della riga 1
					call		        LCD_MOVE_LOC_R1

                    movlw               c_S                                             ;espongo scritta Sin
                    call                LCD_SEND_DATA
                    movlw               c_i
                    call                LCD_SEND_DATA
                    movlw               c_n
                    call                LCD_SEND_DATA
                    return

EXPO_TRI            movlw		        d'7'                                            ;mi sposto in posizione 7 della riga 1
					call		        LCD_MOVE_LOC_R1

                    movlw               c_T                                             ;espongo scritta Tri
                    call                LCD_SEND_DATA
                    movlw               c_r
                    call                LCD_SEND_DATA
                    movlw               c_i
                    call                LCD_SEND_DATA
                    return

EXPO_SQU            movlw		        d'7'                                            ;mi sposto in posizione 7 della riga 1
					call		        LCD_MOVE_LOC_R1

                    movlw               c_S                                             ;espongo scritta Squ
                    call                LCD_SEND_DATA
                    movlw               c_q
                    call                LCD_SEND_DATA
                    movlw               c_u
                    call                LCD_SEND_DATA
                    return
;
;**************************************************************************************************************************************************
; FUNCTION:         EXPO_FREQ
; Input:            freq_ins_0, freq_ins_1, freq_ins_2, freq_ins_3, freq_ins_4, freq_ins_5, freq_ins_6
; Overview:         Espone la frequenza selezionata modificando l'unit di misura
;**************************************************************************************************************************************************
;
EXPO_FREQ           movf				freq_ins_6,W									;se freq_ins_6  0
					xorlw               h'0'       									    ;
					btfss               STATUS,Z                                        ;salta
                    goto				EXPO_MHZ										;altrimenti esponi i MHz

					movf                freq_ins_5,W									;controllo qual' la prima cifra da
					xorlw				h'0'											;scrivere e vado al ciclo di scrittura
					btfss				STATUS,Z										;adeguato
					goto				EXPO_KHZ_3

					movf                freq_ins_4,W
					xorlw				h'0'
					btfss				STATUS,Z
					goto				EXPO_KHZ_2

					movf                freq_ins_3,W
					xorlw				h'0'
					btfss				STATUS,Z
					goto				EXPO_KHZ_1

					movf                freq_ins_2,W
					xorlw				h'0'
					btfss				STATUS,Z
					goto				EXPO_HZ_3

					movf                freq_ins_1,W
					xorlw				h'0'
					btfss				STATUS,Z
					goto				EXPO_HZ_2
					goto				EXPO_HZ_1

EXPO_MHZ            movlw               d'7'                                            ;mi sposto in posizione 7 della seconda riga
                    call                LCD_MOVE_LOC_R2

                    movf                freq_ins_6,W                                    ;espongo il primo valore
                    call                LCD_SEND_NUMBER

                    movlw               h'2C'                                           ;espongo la virgola
                    call                LCD_SEND_DATA

                    movf                freq_ins_5,W                                    ;espongo gli altri valori
                    call                LCD_SEND_NUMBER
                    movf                freq_ins_4,W
                    call                LCD_SEND_NUMBER
                    movf                freq_ins_3,W
                    call                LCD_SEND_NUMBER

                    movlw               c_.                                             ;espongo il .
                    call                LCD_SEND_DATA

                    movf                freq_ins_2,W
                    call                LCD_SEND_NUMBER
                    movf                freq_ins_1,W
                    call                LCD_SEND_NUMBER
                    movf                freq_ins_0,W
                    call                LCD_SEND_NUMBER

                    movlw               c_M		                                        ;spazio
                    call                LCD_SEND_DATA
                    movlw               c_H
                    call                LCD_SEND_DATA
                    movlw               c_z
                    call                LCD_SEND_DATA

                    return

EXPO_KHZ_3          movlw               d'7'                                            ;mi sposto in posizione 7 della seconda riga
                    call                LCD_MOVE_LOC_R2

                    movlw               c_                                              ;espongo uno spazio per cancellare precedenti valori se presenti
                    call                LCD_SEND_DATA

                    movlw               c_                                              ;espongo uno spazio per cancellare precedenti valori se presenti
                    call                LCD_SEND_DATA

                    movf                freq_ins_5,W                                    ;espongo gli altri valori
                    call                LCD_SEND_NUMBER
                    movf                freq_ins_4,W
                    call                LCD_SEND_NUMBER
                    movf                freq_ins_3,W
                    call                LCD_SEND_NUMBER

                    movlw               h'2C'                                           ;espongo la ,
                    call                LCD_SEND_DATA

                    movf                freq_ins_2,W
                    call                LCD_SEND_NUMBER
                    movf                freq_ins_1,W
                    call                LCD_SEND_NUMBER
                    movf                freq_ins_0,W
                    call                LCD_SEND_NUMBER

                    movlw               c_K		                                        ;spazio
                    call                LCD_SEND_DATA
                    movlw               c_H
                    call                LCD_SEND_DATA
                    movlw               c_z
                    call                LCD_SEND_DATA

                    return

EXPO_KHZ_2          movlw               d'7'                                            ;mi sposto in posizione 7 della seconda riga
                    call                LCD_MOVE_LOC_R2

                    movlw               c_                                              ;espongo uno spazio per cancellare precedenti valori se presenti
                    call                LCD_SEND_DATA

                    movlw               c_                                              ;espongo uno spazio per cancellare precedenti valori se presenti
                    call                LCD_SEND_DATA

                    movlw               c_                                              ;espongo uno spazio per cancellare precedenti valori se presenti
                    call                LCD_SEND_DATA
                    movf                freq_ins_4,W
                    call                LCD_SEND_NUMBER
                    movf                freq_ins_3,W
                    call                LCD_SEND_NUMBER

                    movlw               h'2C'                                           ;espongo la ,
                    call                LCD_SEND_DATA

                    movf                freq_ins_2,W
                    call                LCD_SEND_NUMBER
                    movf                freq_ins_1,W
                    call                LCD_SEND_NUMBER
                    movf                freq_ins_0,W
                    call                LCD_SEND_NUMBER

                    movlw               c_K		                                        ;spazio
                    call                LCD_SEND_DATA
                    movlw               c_H
                    call                LCD_SEND_DATA
                    movlw               c_z
                    call                LCD_SEND_DATA

                    return

EXPO_KHZ_1          movlw               d'7'                                            ;mi sposto in posizione 7 della seconda riga
                    call                LCD_MOVE_LOC_R2

                    movlw               c_                                              ;espongo uno spazio per cancellare precedenti valori se presenti
                    call                LCD_SEND_DATA

                    movlw               c_                                              ;espongo uno spazio per cancellare precedenti valori se presenti
                    call                LCD_SEND_DATA

                    movlw               c_                                              ;espongo uno spazio per cancellare precedenti valori se presenti
                    call                LCD_SEND_DATA
                    movlw               c_                                              ;espongo uno spazio per cancellare precedenti valori se presenti
                    call                LCD_SEND_DATA
                    movf                freq_ins_3,W
                    call                LCD_SEND_NUMBER

                    movlw               h'2C'                                           ;espongo la ,
                    call                LCD_SEND_DATA

                    movf                freq_ins_2,W
                    call                LCD_SEND_NUMBER
                    movf                freq_ins_1,W
                    call                LCD_SEND_NUMBER
                    movf                freq_ins_0,W
                    call                LCD_SEND_NUMBER

                    movlw               c_K		                                        ;spazio
                    call                LCD_SEND_DATA
                    movlw               c_H
                    call                LCD_SEND_DATA
                    movlw               c_z
                    call                LCD_SEND_DATA

                    return

EXPO_HZ_3           movlw               d'7'                                            ;mi sposto in posizione 7 della seconda riga
                    call                LCD_MOVE_LOC_R2

                    movlw               c_                                              ;espongo uno spazio per cancellare precedenti valori se presenti
                    call                LCD_SEND_DATA

                    movlw               c_                                              ;espongo uno spazio per cancellare precedenti valori se presenti
                    call                LCD_SEND_DATA

                    movlw               c_                                              ;espongo uno spazio per cancellare precedenti valori se presenti
                    call                LCD_SEND_DATA
                    movlw               c_                                              ;espongo uno spazio per cancellare precedenti valori se presenti
                    call                LCD_SEND_DATA
                    movlw               c_                                              ;espongo uno spazio per cancellare precedenti valori se presenti
                    call                LCD_SEND_DATA

                    movlw               c_                                              ;espongo uno spazio per cancellare precedenti valori se presenti
                    call                LCD_SEND_DATA

                    movf                freq_ins_2,W
                    call                LCD_SEND_NUMBER
                    movf                freq_ins_1,W
                    call                LCD_SEND_NUMBER
                    movf                freq_ins_0,W
                    call                LCD_SEND_NUMBER

                    movlw               c_		                                        ;spazio
                    call                LCD_SEND_DATA
                    movlw               c_H
                    call                LCD_SEND_DATA
                    movlw               c_z
                    call                LCD_SEND_DATA

                    return

EXPO_HZ_2           movlw               d'7'                                            ;mi sposto in posizione 7 della seconda riga
                    call                LCD_MOVE_LOC_R2

                    movlw               c_                                              ;espongo uno spazio per cancellare precedenti valori se presenti
                    call                LCD_SEND_DATA

                    movlw               c_                                              ;espongo uno spazio per cancellare precedenti valori se presenti
                    call                LCD_SEND_DATA

                    movlw               c_                                              ;espongo uno spazio per cancellare precedenti valori se presenti
                    call                LCD_SEND_DATA
                    movlw               c_                                              ;espongo uno spazio per cancellare precedenti valori se presenti
                    call                LCD_SEND_DATA
                    movlw               c_                                              ;espongo uno spazio per cancellare precedenti valori se presenti
                    call                LCD_SEND_DATA

                    movlw               c_                                              ;espongo uno spazio per cancellare precedenti valori se presenti
                    call                LCD_SEND_DATA

                    movlw               c_                                              ;espongo uno spazio per cancellare precedenti valori se presenti
                    call                LCD_SEND_DATA
                    movf                freq_ins_1,W
                    call                LCD_SEND_NUMBER
                    movf                freq_ins_0,W
                    call                LCD_SEND_NUMBER

                    movlw               c_		                                        ;spazio
                    call                LCD_SEND_DATA
                    movlw               c_H
                    call                LCD_SEND_DATA
                    movlw               c_z
                    call                LCD_SEND_DATA

                    return

EXPO_HZ_1           movlw               d'7'                                            ;mi sposto in posizione 7 della seconda riga
                    call                LCD_MOVE_LOC_R2

                    movlw               c_                                              ;espongo uno spazio per cancellare precedenti valori se presenti
                    call                LCD_SEND_DATA

                    movlw               c_                                              ;espongo uno spazio per cancellare precedenti valori se presenti
                    call                LCD_SEND_DATA

                    movlw               c_                                              ;espongo uno spazio per cancellare precedenti valori se presenti
                    call                LCD_SEND_DATA
                    movlw               c_                                              ;espongo uno spazio per cancellare precedenti valori se presenti
                    call                LCD_SEND_DATA
                    movlw               c_                                              ;espongo uno spazio per cancellare precedenti valori se presenti
                    call                LCD_SEND_DATA

                    movlw               c_                                              ;espongo uno spazio per cancellare precedenti valori se presenti
                    call                LCD_SEND_DATA

                    movlw               c_                                              ;espongo uno spazio per cancellare precedenti valori se presenti
                    call                LCD_SEND_DATA
                    movlw               c_                                              ;espongo uno spazio per cancellare precedenti valori se presenti
                    call                LCD_SEND_DATA
                    movf                freq_ins_0,W
                    call                LCD_SEND_NUMBER

                    movlw               c_		                                        ;spazio
                    call                LCD_SEND_DATA
                    movlw               c_H
                    call                LCD_SEND_DATA
                    movlw               c_z
                    call                LCD_SEND_DATA

                    return
;
;**************************************************************************************************************************************************
; FUNCTION:         EXPO_PHASE
; Input:            phase_h
; Overview:         Espone la fase selezionata a seconda del valore di phase_h
;**************************************************************************************************************************************************
;
EXPO_PHASE          movf                phase_h,W                                       ;se phase_h = 0
                    btfsc               STATUS,Z
                    goto                EXPO_PHASE_0                                    ;vado a EXPO_PHASE_0
                    xorlw               h'2'                                            ;se phase_h = 2
                    btfsc               STATUS,Z
                    goto                EXPO_PHASE_45                                   ;vado a EXPO_PHASE_45
                    movf                phase_h,W
                    xorlw               h'4'
                    btfsc               STATUS,Z
                    goto                EXPO_PHASE_90
                    movf                phase_h,W
                    xorlw               h'6'
                    btfsc               STATUS,Z
                    goto                EXPO_PHASE_135
                    movf                phase_h,W
                    xorlw               h'8'
                    btfsc               STATUS,Z
                    goto                EXPO_PHASE_180
                    movf                phase_h,W
                    xorlw               h'A'
                    btfsc               STATUS,Z
                    goto                EXPO_PHASE_225
                    movf                phase_h,W
                    xorlw               h'C'
                    btfsc               STATUS,Z
                    goto                EXPO_PHASE_270
                    movf                phase_h,W
                    xorlw               h'E'
                    btfsc               STATUS,Z
                    goto                EXPO_PHASE_315

                    call                EXPO_ERR_PHASE                                  ;se nessuna delle condizioni precedenti si  verificata espongo l'errore
ERR_LOOP_1          goto                ERR_LOOP_1                                      ;e resto qui  (usato in fase di debug, normalmente non dovrebbe mai verificarsi
                                                                                        ;questa condizione)

EXPO_PHASE_0        movlw               d'7'
                    call                LCD_MOVE_LOC_R3

                    movlw               c_
                    call                LCD_SEND_DATA
                    movlw               c_
                    call                LCD_SEND_DATA
                    movlw               h'0'
                    call                LCD_SEND_NUMBER
                    movlw               h'DF'
                    call                LCD_SEND_DATA
                    return

EXPO_PHASE_45       movlw               d'7'
                    call                LCD_MOVE_LOC_R3

                    movlw               c_
                    call                LCD_SEND_DATA
                    movlw               d'4'
                    call                LCD_SEND_NUMBER
                    movlw               d'5'
                    call                LCD_SEND_NUMBER
                    movlw               h'DF'
                    call                LCD_SEND_DATA
                    return

EXPO_PHASE_90       movlw               d'7'
                    call                LCD_MOVE_LOC_R3

                    movlw               c_
                    call                LCD_SEND_DATA
                    movlw               d'9'
                    call                LCD_SEND_NUMBER
                    movlw               d'0'
                    call                LCD_SEND_NUMBER
                    movlw               h'DF'
                    call                LCD_SEND_DATA
                    return

EXPO_PHASE_135      movlw               d'7'
                    call                LCD_MOVE_LOC_R3

                    movlw               d'1'
                    call                LCD_SEND_NUMBER
                    movlw               d'3'
                    call                LCD_SEND_NUMBER
                    movlw               d'5'
                    call                LCD_SEND_NUMBER
                    movlw               h'DF'
                    call                LCD_SEND_DATA
                    return

EXPO_PHASE_180      movlw               d'7'
                    call                LCD_MOVE_LOC_R3

                    movlw               d'1'
                    call                LCD_SEND_NUMBER
                    movlw               d'8'
                    call                LCD_SEND_NUMBER
                    movlw               d'0'
                    call                LCD_SEND_NUMBER
                    movlw               h'DF'
                    call                LCD_SEND_DATA
                    return

EXPO_PHASE_225      movlw               d'7'
                    call                LCD_MOVE_LOC_R3

                    movlw               d'2'
                    call                LCD_SEND_NUMBER
                    movlw               d'2'
                    call                LCD_SEND_NUMBER
                    movlw               d'5'
                    call                LCD_SEND_NUMBER
                    movlw               h'DF'
                    call                LCD_SEND_DATA
                    return

EXPO_PHASE_270      movlw               d'7'
                    call                LCD_MOVE_LOC_R3

                    movlw               d'2'
                    call                LCD_SEND_NUMBER
                    movlw               d'7'
                    call                LCD_SEND_NUMBER
                    movlw               d'0'
                    call                LCD_SEND_NUMBER
                    movlw               h'DF'
                    call                LCD_SEND_DATA
                    return

EXPO_PHASE_315      movlw               d'7'
                    call                LCD_MOVE_LOC_R3

                    movlw               d'3'
                    call                LCD_SEND_NUMBER
                    movlw               d'1'
                    call                LCD_SEND_NUMBER
                    movlw               d'5'
                    call                LCD_SEND_NUMBER
                    movlw               h'DF'
                    call                LCD_SEND_DATA
                    return
;
;**************************************************************************************************************************************************
; FUNCTION:         EXPO_VPP
; Input:            vpp
; Overview:         Espone il valore corretto di Vpp a seconda del valore in vpp e dell'onda selezionata
;**************************************************************************************************************************************************
;
EXPO_VPP            movlw               d'6'
                    call                LCD_MOVE_LOC_R4

                    movf                shape,W                                         ;shape = 0 (onda quadra)
                    btfsc               STATUS,Z
                    goto                EXPO_VPP_SQU                                    ;vado a EXPO_VPP_SQU

                    movf                vpp,W                                           ;a seconda del valore di VPP vado al ciclo di scrittura adeguato
                    xorlw               h'01'
                    btfsc               STATUS,Z
                    goto                EXPO_VPP_02

                    movf                vpp,W
                    xorlw               h'02'
                    btfsc               STATUS,Z
                    goto                EXPO_VPP_03

                    movf                vpp,W
                    xorlw               h'03'
                    btfsc               STATUS,Z
                    goto                EXPO_VPP_05

                    movf                vpp,W
                    xorlw               h'04'
                    btfsc               STATUS,Z
                    goto                EXPO_VPP_10

                    movf                vpp,W
                    xorlw               h'05'
                    btfsc               STATUS,Z
                    goto                EXPO_VPP_15

                    movf                vpp,W
                    xorlw               h'06'
                    btfsc               STATUS,Z
                    goto                EXPO_VPP_20

                    movf                vpp,W
                    xorlw               h'07'
                    btfsc               STATUS,Z
                    goto                EXPO_VPP_30

                    movf                vpp,W
                    xorlw               h'08'
                    btfsc               STATUS,Z
                    goto                EXPO_VPP_50


                    call                EXPO_ERR_VPP                                    ;se nessuno dei valori precedenti espongo l'errore
ERR_LOOP_3          goto                ERR_LOOP_3                                      ;e mi fermo qui (usato in fase di debug, non dovrebbe mai verificarsi
                                                                                        ;questa condizione)

EXPO_VPP_02         movlw               c_
                    call                LCD_SEND_DATA
                    movlw               d'0'
                    call                LCD_SEND_NUMBER
                    movlw               c_.
                    call                LCD_SEND_DATA
                    movlw               d'2'
                    call                LCD_SEND_NUMBER
                    movlw               c_V
                    call                LCD_SEND_DATA
                    return

EXPO_VPP_03         movlw               c_
                    call                LCD_SEND_DATA
                    movlw               d'0'
                    call                LCD_SEND_NUMBER
                    movlw               c_.
                    call                LCD_SEND_DATA
                    movlw               d'3'
                    call                LCD_SEND_NUMBER
                    movlw               c_V
                    call                LCD_SEND_DATA
                    return

EXPO_VPP_05         movlw               c_
                    call                LCD_SEND_DATA
                    movlw               d'0'
                    call                LCD_SEND_NUMBER
                    movlw               c_.
                    call                LCD_SEND_DATA
                    movlw               d'5'
                    call                LCD_SEND_NUMBER
                    movlw               c_V
                    call                LCD_SEND_DATA
                    return

EXPO_VPP_10         movlw               c_
                    call                LCD_SEND_DATA
                    movlw               d'1'
                    call                LCD_SEND_NUMBER
                    movlw               c_.
                    call                LCD_SEND_DATA
                    movlw               d'0'
                    call                LCD_SEND_NUMBER
                    movlw               c_V
                    call                LCD_SEND_DATA
                    return

EXPO_VPP_15         movlw               c_
                    call                LCD_SEND_DATA
                    movlw               d'1'
                    call                LCD_SEND_NUMBER
                    movlw               c_.
                    call                LCD_SEND_DATA
                    movlw               d'5'
                    call                LCD_SEND_NUMBER
                    movlw               c_V
                    call                LCD_SEND_DATA
                    return

EXPO_VPP_20         movlw               c_
                    call                LCD_SEND_DATA
                    movlw               d'2'
                    call                LCD_SEND_NUMBER
                    movlw               c_.
                    call                LCD_SEND_DATA
                    movlw               d'0'
                    call                LCD_SEND_NUMBER
                    movlw               c_V
                    call                LCD_SEND_DATA
                    return

EXPO_VPP_30         movlw               c_
                    call                LCD_SEND_DATA
                    movlw               d'3'
                    call                LCD_SEND_NUMBER
                    movlw               c_.
                    call                LCD_SEND_DATA
                    movlw               d'0'
                    call                LCD_SEND_NUMBER
                    movlw               c_V
                    call                LCD_SEND_DATA
                    return

EXPO_VPP_50         movlw               c_
                    call                LCD_SEND_DATA
                    movlw               d'5'
                    call                LCD_SEND_NUMBER
                    movlw               c_.
                    call                LCD_SEND_DATA
                    movlw               d'0'
                    call                LCD_SEND_NUMBER
                    movlw               c_V
                    call                LCD_SEND_DATA
                    return



EXPO_VPP_SQU        movf                vpp,W
                    xorlw               h'01'
                    btfsc               STATUS,Z
                    goto                EXPO_VPP_SQU_05

                    movf                vpp,W
                    xorlw               h'02'
                    btfsc               STATUS,Z
                    goto                EXPO_VPP_SQU_08

                    movf                vpp,W
                    xorlw               h'03'
                    btfsc               STATUS,Z
                    goto                EXPO_VPP_SQU_15

                    movf                vpp,W
                    xorlw               h'04'
                    btfsc               STATUS,Z
                    goto                EXPO_VPP_SQU_28

                    movf                vpp,W
                    xorlw               h'05'
                    btfsc               STATUS,Z
                    goto                EXPO_VPP_SQU_40

                    movf                vpp,W
                    xorlw               h'06'
                    btfsc               STATUS,Z
                    goto                EXPO_VPP_SQU_55

                    movf                vpp,W
                    xorlw               h'07'
                    btfsc               STATUS,Z
                    goto                EXPO_VPP_SQU_85

                    movf                vpp,W
                    xorlw               h'08'
                    btfsc               STATUS,Z
                    goto                EXPO_VPP_SQU_14

                    call                EXPO_ERR_VPP_SQU                                ;se nessuno dei valori precedenti espongo l'errore
ERR_LOOP_4          goto                ERR_LOOP_4                                      ;e mi fermo qui (usato in fase di debug, non dovrebbe mai verificarsi
                                                                                        ;questa condizione)

EXPO_VPP_SQU_05     movlw               c_
                    call                LCD_SEND_DATA
                    movlw               d'0'
                    call                LCD_SEND_NUMBER
                    movlw               c_.
                    call                LCD_SEND_DATA
                    movlw               d'5'
                    call                LCD_SEND_NUMBER
                    movlw               c_V
                    call                LCD_SEND_DATA
                    return

EXPO_VPP_SQU_08
                    movlw               c_
                    call                LCD_SEND_DATA
                    movlw               d'0'
                    call                LCD_SEND_NUMBER
                    movlw               c_.
                    call                LCD_SEND_DATA
                    movlw               d'8'
                    call                LCD_SEND_NUMBER
                    movlw               c_V
                    call                LCD_SEND_DATA
                    return

EXPO_VPP_SQU_15     movlw               c_
                    call                LCD_SEND_DATA
                    movlw               d'1'
                    call                LCD_SEND_NUMBER
                    movlw               c_.
                    call                LCD_SEND_DATA
                    movlw               d'5'
                    call                LCD_SEND_NUMBER
                    movlw               c_V
                    call                LCD_SEND_DATA
                    return

EXPO_VPP_SQU_28     movlw               c_
                    call                LCD_SEND_DATA
                    movlw               d'2'
                    call                LCD_SEND_NUMBER
                    movlw               c_.
                    call                LCD_SEND_DATA
                    movlw               d'8'
                    call                LCD_SEND_NUMBER
                    movlw               c_V
                    call                LCD_SEND_DATA
                    return

EXPO_VPP_SQU_40     movlw               c_
                    call                LCD_SEND_DATA
                    movlw               d'4'
                    call                LCD_SEND_NUMBER
                    movlw               c_.
                    call                LCD_SEND_DATA
                    movlw               d'0'
                    call                LCD_SEND_NUMBER
                    movlw               c_V
                    call                LCD_SEND_DATA
                    return

EXPO_VPP_SQU_55     movlw               c_
                    call                LCD_SEND_DATA
                    movlw               d'5'
                    call                LCD_SEND_NUMBER
                    movlw               c_.
                    call                LCD_SEND_DATA
                    movlw               d'5'
                    call                LCD_SEND_NUMBER
                    movlw               c_V
                    call                LCD_SEND_DATA
                    return

EXPO_VPP_SQU_85     movlw               c_
                    call                LCD_SEND_DATA
                    movlw               d'8'
                    call                LCD_SEND_NUMBER
                    movlw               c_.
                    call                LCD_SEND_DATA
                    movlw               d'5'
                    call                LCD_SEND_NUMBER
                    movlw               c_V
                    call                LCD_SEND_DATA
                    return

EXPO_VPP_SQU_14     movlw               d'1'
                    call                LCD_SEND_NUMBER
                    movlw               d'4'
                    call                LCD_SEND_NUMBER
                    movlw               c_.
                    call                LCD_SEND_DATA
                    movlw               d'0'
                    call                LCD_SEND_NUMBER
                    movlw               c_V
                    call                LCD_SEND_DATA
                    return
;
;**************************************************************************************************************************************************
; FUNCTION:         EXPO_BACKILL
; Input:            CCPR2L
; Overview:         Espone il valore della retroilluminazione impostato a scatti del 10%
;**************************************************************************************************************************************************
;
EXPO_BACKILL        movff               CCPR2L,temp                                     ;salvo il valore del duty in una variabile temporanea

                    movlw               h'FF'                                           ;adattamento contatore
                    movwf               count

COUNT_BACK_ILL      incf                count,F                                         ;sottraggo 19 al valore del duty e ogni volta incremento il
                    movlw               h'19'                                           ;contatore
                    subwf               temp,F
                    btfsc               STATUS,C                                        ;se vado in negativo esco dal ciclo
                    goto                COUNT_BACK_ILL

                    movf                count,W                                         ;se ho contato 10 step
                    xorlw               h'A'
                    btfsc               STATUS,Z
                    goto                EXPO_100_B                                      ;esponi 100

                    movlw               d'10'
                    call                LCD_MOVE_LOC_R1

                    movlw               c_                                              ;altrimenti esponi il numero del contatore seguito da 0
                    call                LCD_SEND_DATA
                    movf                count,W
                    call                LCD_SEND_NUMBER
                    movlw               d'0'
                    call                LCD_SEND_NUMBER

                    movlw               h'25'                                           ;espongo %
                    call                LCD_SEND_DATA

                    return

EXPO_100_B          movlw               d'10'
                    call                LCD_MOVE_LOC_R1

                    movlw               d'1'
                    call                LCD_SEND_NUMBER
                    movlw               d'0'
                    call                LCD_SEND_NUMBER
                    movlw               d'0'
                    call                LCD_SEND_NUMBER

                    movlw               h'25'                                           ;espongo %
                    call                LCD_SEND_DATA

                    return
;
;**************************************************************************************************************************************************
; FUNCTION:         EXPO_CONTR
; Input:            CCPR1L
; Overview:         Espone il valore del contrasto impostato a scatti del 10%
;**************************************************************************************************************************************************
;
EXPO_CONTR          movff               CCPR1L,temp                                     ;salvo il valore del duty in una variabile temporanea

                    movlw               h'B'                                            ;adattamento contatore
                    movwf               count

COUNT_CONTR         decf                count,F                                         ;decremento il contatore ogni volta che sottraggo 10
                    movlw               h'10'
                    subwf               temp,F
                    btfsc               STATUS,C                                        ;se vado in negativo esco
                    goto                COUNT_CONTR

                    movf                count,W                                         ;se il contatore  10 espongo 100
                    xorlw               h'A'
                    btfsc               STATUS,Z
                    goto                EXPO_100_C

                    movlw               d'10'
                    call                LCD_MOVE_LOC_R2

                    movlw               c_                                              ;altrimenti espongo il valore del contatore seguito da 0
                    call                LCD_SEND_DATA
                    movf                count,W
                    call                LCD_SEND_NUMBER
                    movlw               d'0'
                    call                LCD_SEND_NUMBER

                    movlw               h'25'                                           ;espongo %
                    call                LCD_SEND_DATA

                    return

EXPO_100_C          movlw               d'10'
                    call                LCD_MOVE_LOC_R2

                    movlw               d'1'
                    call                LCD_SEND_NUMBER
                    movlw               d'0'
                    call                LCD_SEND_NUMBER
                    movlw               d'0'
                    call                LCD_SEND_NUMBER

                    movlw               h'25'                                           ;espongo %
                    call                LCD_SEND_DATA

                    return
;
;**************************************************************************************************************************************************
; FUNCTION:         EXPO_OFFSET
; Input:            pot_offset_sin
; Overview:         Espone il valore dell'offset sull'LCD
;**************************************************************************************************************************************************
;
EXPO_OFFSET_SIN     movff               pot_offset_sin,hex_data
                    call                HEX1_TO_BCD3                                    ;converto il valore dell'offset da esadecimale a 3 byte BCD
                    movlw               d'10'
                    call                LCD_MOVE_LOC_R3
                    movf                bcd_cent,W                                      ;scrivo i valori ottenuti
                    call                LCD_SEND_NUMBER
                    movf                bcd_dec,W
                    call                LCD_SEND_NUMBER
                    movf                bcd_unit,W
                    call                LCD_SEND_NUMBER

                    return
;
;**************************************************************************************************************************************************
; FUNCTION:         EXPO_OFFSET_SQU
; Input:            pot_offset_squ
; Overview:         Espone il valore dell'offset dell'onda quadra sull'LCD
;**************************************************************************************************************************************************
;
EXPO_OFFSET_SQU     movff               pot_offset_squ,hex_data
                    call                HEX1_TO_BCD3
                    movlw               d'10'
                    call                LCD_MOVE_LOC_R4
                    movf                bcd_cent,W
                    call                LCD_SEND_NUMBER
                    movf                bcd_dec,W
                    call                LCD_SEND_NUMBER
                    movf                bcd_unit,W
                    call                LCD_SEND_NUMBER

                    return
;
;**************************************************************************************************************************************************
;**************************************************************************************************************************************************
;MESSAGGI DI ERRORE
;**************************************************************************************************************************************************
;**************************************************************************************************************************************************
; FUNCTION:         EXPO_ERR_SHAPE
; Overview:         Espone il messagio di errore in fase di decodifica della forma d'onda
;**************************************************************************************************************************************************
;
EXPO_ERR_SHAPE      movlw               LCD_CLEAR
                    call                LCD_SEND_CODE

                    movlw				d'0'
					call		        LCD_MOVE_LOC_R1

                    movlw		        c_E
					call		        LCD_SEND_DATA
                    movlw		        c_R
					call		        LCD_SEND_DATA
                    movlw		        c_R
					call		        LCD_SEND_DATA
                    movlw		        c_O
					call		        LCD_SEND_DATA
                    movlw		        c_R
					call		        LCD_SEND_DATA
                    movlw		        h'3A'
					call		        LCD_SEND_DATA
                    movlw		        c_
					call		        LCD_SEND_DATA
                    movlw		        c_S
					call		        LCD_SEND_DATA
                    movlw		        c_H
					call		        LCD_SEND_DATA
                    movlw		        c_A
					call		        LCD_SEND_DATA
                    movlw		        c_P
					call		        LCD_SEND_DATA
                    movlw		        c_E
					call		        LCD_SEND_DATA
                    movlw		        c_
					call		        LCD_SEND_DATA
                    movlw		        c_O
					call		        LCD_SEND_DATA
                    movlw		        c_U
					call		        LCD_SEND_DATA
                    movlw		        c_T
					call		        LCD_SEND_DATA
                    movlw		        c_
					call		        LCD_SEND_DATA
                    movlw		        c_O
					call		        LCD_SEND_DATA
                    movlw		        c_F
					call		        LCD_SEND_DATA

                    movlw				d'0'
					call		        LCD_MOVE_LOC_R2

                    movlw		        c_R
					call		        LCD_SEND_DATA
                    movlw		        c_A
					call		        LCD_SEND_DATA
                    movlw		        c_N
					call		        LCD_SEND_DATA
                    movlw		        c_G
					call		        LCD_SEND_DATA
                    movlw		        c_E
                    call		        LCD_SEND_DATA

					return
;
;**************************************************************************************************************************************************
; FUNCTION:         EXPO_ERR_PHASE
; Overview:         Espone il messagio di errore in fase di decodifica della fase
;**************************************************************************************************************************************************
;
EXPO_ERR_PHASE      movlw               LCD_CLEAR
                    call                LCD_SEND_CODE

                    movlw				d'0'
					call		        LCD_MOVE_LOC_R1

                    movlw		        c_E
					call		        LCD_SEND_DATA
                    movlw		        c_R
					call		        LCD_SEND_DATA
                    movlw		        c_R
					call		        LCD_SEND_DATA
                    movlw		        c_O
					call		        LCD_SEND_DATA
                    movlw		        c_R
                    call		        LCD_SEND_DATA
                    movlw		        h'3A'
					call		        LCD_SEND_DATA
                    movlw		        c_
					call		        LCD_SEND_DATA
                    movlw		        c_P
					call		        LCD_SEND_DATA
                    movlw		        c_H
					call		        LCD_SEND_DATA
                    movlw		        c_A
					call		        LCD_SEND_DATA
                    movlw		        c_S
					call		        LCD_SEND_DATA
                    movlw		        c_E
					call		        LCD_SEND_DATA
                    movlw		        c_
					call		        LCD_SEND_DATA
                    movlw		        c_O
					call		        LCD_SEND_DATA
                    movlw		        c_U
					call		        LCD_SEND_DATA
                    movlw		        c_T
					call		        LCD_SEND_DATA
                    movlw		        c_
					call		        LCD_SEND_DATA
                    movlw		        c_O
					call		        LCD_SEND_DATA
                    movlw		        c_F
					call		        LCD_SEND_DATA

                    movlw				d'0'
					call		        LCD_MOVE_LOC_R2

                    movlw		        c_R
					call		        LCD_SEND_DATA
                    movlw		        c_A
					call		        LCD_SEND_DATA
                    movlw		        c_N
					call		        LCD_SEND_DATA
                    movlw		        c_G
					call		        LCD_SEND_DATA
                    movlw		        c_E
                    call		        LCD_SEND_DATA

					return
;
;**************************************************************************************************************************************************
; FUNCTION:         EXPO_ERR_VPP
; Overview:         Espone il messagio di errore in fase di decodifica della fase
;**************************************************************************************************************************************************
;
EXPO_ERR_VPP        movlw               LCD_CLEAR
                    call                LCD_SEND_CODE

                    movlw				d'0'
					call		        LCD_MOVE_LOC_R1

                    movlw		        c_E
					call		        LCD_SEND_DATA
                    movlw		        c_R
					call		        LCD_SEND_DATA
                    movlw		        c_R
					call		        LCD_SEND_DATA
                    movlw		        c_O
					call		        LCD_SEND_DATA
                    movlw		        c_R
                    call		        LCD_SEND_DATA
                    movlw		        h'3A'
					call		        LCD_SEND_DATA
                    movlw		        c_
					call		        LCD_SEND_DATA
                    movlw		        c_V
					call		        LCD_SEND_DATA
                    movlw		        c_P
					call		        LCD_SEND_DATA
                    movlw		        c_P
					call		        LCD_SEND_DATA
                    movlw		        c_
					call		        LCD_SEND_DATA
                    movlw		        c_O
					call		        LCD_SEND_DATA
                    movlw		        c_U
					call		        LCD_SEND_DATA
                    movlw		        c_T
					call		        LCD_SEND_DATA
                    movlw		        c_
					call		        LCD_SEND_DATA
                    movlw		        c_O
					call		        LCD_SEND_DATA
                    movlw		        c_F
					call		        LCD_SEND_DATA

                    movlw				d'0'
					call		        LCD_MOVE_LOC_R2

                    movlw		        c_R
					call		        LCD_SEND_DATA
                    movlw		        c_A
					call		        LCD_SEND_DATA
                    movlw		        c_N
					call		        LCD_SEND_DATA
                    movlw		        c_G
					call		        LCD_SEND_DATA
                    movlw		        c_E
                    call		        LCD_SEND_DATA

					return
;
;**************************************************************************************************************************************************
; FUNCTION:         EXPO_ERR_VPP_SQU
; Overview:         Espone il messagio di errore in fase di decodifica della fase
;**************************************************************************************************************************************************
;
EXPO_ERR_VPP_SQU    movlw               LCD_CLEAR
                    call                LCD_SEND_CODE

                    movlw				d'0'
					call		        LCD_MOVE_LOC_R1

                    movlw		        c_E
					call		        LCD_SEND_DATA
                    movlw		        c_R
					call		        LCD_SEND_DATA
                    movlw		        c_R
					call		        LCD_SEND_DATA
                    movlw		        c_O
					call		        LCD_SEND_DATA
                    movlw		        c_R
                    call		        LCD_SEND_DATA
                    movlw		        h'3A'
					call		        LCD_SEND_DATA
                    movlw		        c_
					call		        LCD_SEND_DATA
                    movlw		        c_V
					call		        LCD_SEND_DATA
                    movlw		        c_P
					call		        LCD_SEND_DATA
                    movlw		        c_P
					call		        LCD_SEND_DATA
                    movlw		        c_S
					call		        LCD_SEND_DATA
                    movlw		        c_q
					call		        LCD_SEND_DATA
                    movlw		        c_u
					call		        LCD_SEND_DATA
                    movlw		        c_
					call		        LCD_SEND_DATA
                    movlw		        c_O
					call		        LCD_SEND_DATA
                    movlw		        c_U
					call		        LCD_SEND_DATA
                    movlw		        c_T
					call		        LCD_SEND_DATA
                    movlw		        c_
					call		        LCD_SEND_DATA
                    movlw		        c_O
					call		        LCD_SEND_DATA
                    movlw		        c_F
					call		        LCD_SEND_DATA

                    movlw				d'0'
					call		        LCD_MOVE_LOC_R2

                    movlw		        c_R
					call		        LCD_SEND_DATA
                    movlw		        c_A
					call		        LCD_SEND_DATA
                    movlw		        c_N
					call		        LCD_SEND_DATA
                    movlw		        c_G
					call		        LCD_SEND_DATA
                    movlw		        c_E
                    call		        LCD_SEND_DATA

					return
;**************************************************************************************************************************************************
; FUNCTION:         EXPO_RESET
; Overview:         Espone il messagio di reset generico
;**************************************************************************************************************************************************
;
EXPO_RESET          movlw               LCD_CLEAR
                    call                LCD_SEND_CODE

                    movlw				d'0'
					call		        LCD_MOVE_LOC_R1

                    movlw		        c_R
					call		        LCD_SEND_DATA
                    movlw		        c_E
					call		        LCD_SEND_DATA
                    movlw		        c_S
					call		        LCD_SEND_DATA
                    movlw		        c_E
					call		        LCD_SEND_DATA
                    movlw		        c_T
					call		        LCD_SEND_DATA
                    movlw		        c_
					call		        LCD_SEND_DATA
                    movlw		        c_C
					call		        LCD_SEND_DATA
                    movlw		        c_A
					call		        LCD_SEND_DATA
                    movlw		        c_U
					call		        LCD_SEND_DATA
                    movlw		        c_S
					call		        LCD_SEND_DATA
                    movlw		        c_E
					call		        LCD_SEND_DATA
                    movlw		        h'3A'											;:
					call		        LCD_SEND_DATA
                    movlw		        c_
					call		        LCD_SEND_DATA

                    return